<template>
  <div>
    <rui-loading v-if="loading" />
    <rui-alert v-else-if="error" variant="danger">Unable to read file <code>{{ file }}</code></rui-alert>
    <rui-alert v-else-if="content === ''" variant="warning">No content to display</rui-alert>

    <rui-alert v-if="brokenLinks"
               variant="info"
               content="This page is from a raw markdown file. Only the external links will work." />

    <div v-if="document">
      <div ref="input" class="-hidden"><slot /></div>

      <div :class="componentCSS">
        <!-- eslint-disable vue/no-v-html -->
        <div v-if="htmlToc" class="doc-markdown__toc">
          <div class="doc-markdown__toc__wrapper">
            <h2 class="-text--nowrap">Table of content</h2>
            <nav class="doc-markdown__toc__content" v-html="htmlToc" />
          </div>
        </div>
        <div v-if="content" class="doc-markdown__content _writing" v-html="renderedMarkup" />
        <!-- eslint-enable vue/no-v-html -->
      </div>
    </div>
    <!-- eslint-disable vue/no-v-html -->
    <div v-else v-html="renderedMarkup" />
    <!-- eslint-enable vue/no-v-html -->
  </div>
</template>

<script>
import MarkdownIt from 'markdown-it'
import MarkdownItAnchor from 'markdown-it-anchor'
import MarkdownItTocDoneRight from 'markdown-it-toc-done-right'

import highlight from 'highlight.js'
import hSh from 'highlight.js/lib/languages/shell'
import hJs from 'highlight.js/lib/languages/javascript'
import hXml from 'highlight.js/lib/languages/xml'
import hScss from 'highlight.js/lib/languages/scss'
import { RuiAlert, RuiLoading } from '../../../src/components/index.js'

highlight.registerLanguage('shell', hSh)
highlight.registerLanguage('javascript', hJs)
highlight.registerLanguage('xml', hXml)
highlight.registerLanguage('scss', hScss)

const md = MarkdownIt({
  linkify: true,
  html: true,
  highlight: function (str, lang) {
    if (lang && highlight.getLanguage(lang)) {
      try {
        return highlight.highlight(str, { language: lang }).value
      } catch (__) {}
    }

    return ''
  },
})

const permalinkSymbol = '§'
const permalinkSymbolRegex = new RegExp(`${permalinkSymbol}\\s*`)
md.use(MarkdownItAnchor, { permalink: true, permalinkBefore: true, permalinkSymbol, permalinkClass: '-doc-permalink' })
  .use(MarkdownItTocDoneRight, {
    containerClass: 'doc-markdown__toc',
    listClass: '-unstyled',
  })

export default {
  name: 'DocMarkdownRenderer',
  components: { RuiLoading, RuiAlert },
  props: {
    /**
     * File to load, without extension, directly under src/markdown
     *
     * Due to how Vite handles imports, it is not possible to easily throw random paths and expect it to work.
     * Keep the documents right under the "markdown" directory and it will be fine.
     */
    file: { required: false, type: String, default: null },
    /** Raw markdown. Don't use it with "file" */
    raw: { required: false, type: String, default: null },
    /** Whether to structure HTML for a large document */
    document: { required: false, type: Boolean, default: false },
    /** Whether to update the HTML page title with the first H1 value */
    changePageTitle: { required: false, type: Boolean, default: false },
    /**
     * Whether to display a notice about broken links. This is useful when the file has links to other unreachable
     * files.
     */
    brokenLinks: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      error: false,
      loading: false,
      content: null,
      renderedSlot: null,
      htmlToc: null,
    }
  },
  computed: {
    renderedMarkup () { return this.render(this.content) },
    componentCSS () {
      if (!this.document) return null

      return [
        'doc-markdown',
        this.htmlToc && 'doc-markdown--toc',
      ]
    },
  },
  methods: {
    render (string) {
      if (!string || string === '') return ''

      const html = md.render(string).trim()

      if (!this.document) return html

      const template = document.createElement('template')
      template.innerHTML = html
      const toc = template.content.querySelector('.doc-markdown__toc')
      if (toc) {
        template.content.removeChild(toc)
        this.htmlToc = toc.innerHTML
      }

      if (this.changePageTitle) {
        const title = template.content.querySelector('h1:first-child').textContent
        this.$setTitle(title.replace(permalinkSymbolRegex, ''))
      }

      return template.innerHTML
    },
  },
  created () {
    if (this.raw) {
      this.content = this.raw
      return
    }

    if (!this.file) {
      this.$nextTick(() => { this.content = this.$refs.input.innerText })
      return
    }

    this.loading = true
    this.$loadMarkdownFile(this.file)
      .then((r) => { this.content = r.default })
      .catch(() => { this.error = true })
      .then(() => { this.loading = false })
  },
}
</script>
